# Class Ear

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.api.internal.ConventionTask
org.gradle.api.tasks.AbstractCopyTask
org.gradle.api.tasks.bundling.AbstractArchiveTask
org.gradle.api.tasks.bundling.Zip
org.gradle.jvm.tasks.Jar
org.gradle.api.tasks.bundling.Jar
org.gradle.plugins.ear.Ear

All Implemented Interfaces:
  `Comparable<Task>, ContentFilterable, CopyProcessingSpec, CopySourceSpec, CopySpec, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.file.copy.CopySpecSource, org.gradle.api.internal.IConventionAware, org.gradle.api.internal.TaskInternal, ExtensionAware, Task, PatternFilterable, org.gradle.util.Configurable<Task>`

public class Ear extends Jar
Assembles an EAR archive.

## Nested Class Summary

### Nested classes/interfaces inherited from interface Task

`Task.Namer`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`EAR_EXTENSION`

### Fields inherited from class Jar

`DEFAULT_EXTENSION`

### Fields inherited from class Zip

`ZIP_EXTENSION`

### Fields inherited from interface Task

`TASK_ACTION, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

## Constructor Summary

Constructors
Constructor
Description
`Ear()`

## Method Summary

Modifier and Type
Method
Description
`Ear`
`deploymentDescriptor(Closure configureClosure)`
Configures the deployment descriptor for this EAR archive.
`Ear`
`deploymentDescriptor(Action<? super DeploymentDescriptor> configureAction)`
Configures the deployment descriptor for this EAR archive.
`DeploymentDescriptor`
`getDeploymentDescriptor()`
The deployment descriptor configuration.
`CopySpec`
`getLib()`
A location for dependency libraries to include in the 'lib' directory of the EAR archive.
`String`
`getLibDirName()`
The name of the library directory in the EAR file.
`protected ObjectFactory`
`getObjectFactory()`
Injects and returns an instance of `ObjectFactory`.
`CopySpec`
`lib(Closure configureClosure)`
Adds dependency libraries to include in the 'lib' directory of the EAR archive.
`CopySpec`
`lib(Action<? super CopySpec> configureAction)`
Adds dependency libraries to include in the 'lib' directory of the EAR archive.
`void`
`setDeploymentDescriptor(DeploymentDescriptor deploymentDescriptor)`
`void`
`setLibDirName(String libDirName)`

### Methods inherited from class Jar

`manifest`

### Methods inherited from class Jar

`getManifest, getManifestContentCharset, getMetadataCharset, getMetaInf, manifest, metaInf, metaInf, setManifest, setManifestContentCharset, setMetadataCharset`

### Methods inherited from class Zip

`createCopyAction, getCompressor, getEntryCompression, isZip64, setEntryCompression, setZip64`

### Methods inherited from class AbstractArchiveTask

`createCopyActionExecuter, getAppendix, getArchiveName, getArchivePath, getBaseName, getClassifier, getDestinationDir, getExtension, getVersion, into, into, into, isPreserveFileTimestamps, isReproducibleFileOrder, setAppendix, setArchiveName, setBaseName, setClassifier, setDestinationDir, setExtension, setPreserveFileTimestamps, setReproducibleFileOrder, setVersion`

### Methods inherited from class AbstractCopyTask

`copy, createRootSpec, eachFile, eachFile, exclude, exclude, exclude, exclude, expand, filesMatching, filesMatching, filesNotMatching, filesNotMatching, filter, filter, filter, filter, from, from, from, getDirectoryFileTreeFactory, getDirMode, getDuplicatesStrategy, getExcludes, getFileLookup, getFileMode, getFileResolver, getFileSystem, getFilteringCharset, getIncludeEmptyDirs, getIncludes, getInstantiator, getMainSpec, getRootSpec, getSource, include, include, include, include, isCaseSensitive, rename, rename, rename, rename, setCaseSensitive, setDirMode, setDuplicatesStrategy, setExcludes, setFileMode, setFilteringCharset, setIncludeEmptyDirs, setIncludes, with`

### Methods inherited from class org.gradle.api.internal.ConventionTask

`conventionMapping, conventionMapping, getConventionMapping`

### Methods inherited from class DefaultTask

`newInputDirectory, newInputFile, newOutputDirectory, newOutputFile`

### Methods inherited from class org.gradle.api.internal.AbstractTask

`addValidator, appendParallelSafeAction, compareTo, configure, deleteAllActions, dependsOn, dependsOnTaskDidWork, doFirst, doFirst, doFirst, doLast, doLast, doLast, execute, finalizedBy, getActions, getAnt, getAsDynamicObject, getConvention, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExecuter, getExtensions, getFinalizedBy, getGroup, getIdentityPath, getImpliesSubProjects, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOnlyIf, getOutputs, getPath, getProject, getServices, getShouldRunAfter, getStandardOutputCapture, getState, getTaskActions, getTaskDependencies, getTemporaryDir, getTemporaryDirFactory, getValidators, hasProperty, injectIntoNewInstance, isEnabled, isHasCustomActions, leftShift, mustRunAfter, onlyIf, onlyIf, prependParallelSafeAction, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setExecuter, setFinalizedBy, setGroup, setImpliesSubProjects, setMustRunAfter, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### EAR_EXTENSION

public static final String EAR_EXTENSION

See Also:
  - Constant Field Values

## Constructor Details

### Ear

public Ear()

## Method Details

### getObjectFactory

@Incubating @Inject protected ObjectFactory getObjectFactory()
Injects and returns an instance of `ObjectFactory`.

Since:
  4.2

### deploymentDescriptor

public Ear deploymentDescriptor(@DelegatesTo(value=DeploymentDescriptor.class,strategy=1) Closure configureClosure)
Configures the deployment descriptor for this EAR archive.

The given closure is executed to configure the deployment descriptor. The `DeploymentDescriptor` is passed to the closure as its delegate.

Parameters:
  `configureClosure` - The closure.
Returns:
  This.

### deploymentDescriptor

public Ear deploymentDescriptor(Action<? super DeploymentDescriptor> configureAction)
Configures the deployment descriptor for this EAR archive.

The given action is executed to configure the deployment descriptor.

Parameters:
  `configureAction` - The action.
Returns:
  This.
Since:
  3.5

### getLib

@Internal public CopySpec getLib()
A location for dependency libraries to include in the 'lib' directory of the EAR archive.

### lib

public CopySpec lib(@DelegatesTo(value=CopySpec.class,strategy=1) Closure configureClosure)
Adds dependency libraries to include in the 'lib' directory of the EAR archive.

The given closure is executed to configure a `CopySpec`. The `CopySpec` is passed to the closure as its delegate.

Parameters:
  `configureClosure` - The closure.
Returns:
  The created `CopySpec`

### lib

public CopySpec lib(Action<? super CopySpec> configureAction)
Adds dependency libraries to include in the 'lib' directory of the EAR archive.

The given action is executed to configure a `CopySpec`.

Parameters:
  `configureAction` - The action.
Returns:
  The created `CopySpec`
Since:
  3.5

### getLibDirName

@Optional @Input public String getLibDirName()
The name of the library directory in the EAR file. Default is "lib".

### setLibDirName

public void setLibDirName(String libDirName)

### getDeploymentDescriptor

@Internal public DeploymentDescriptor getDeploymentDescriptor()
The deployment descriptor configuration.

### setDeploymentDescriptor

public void setDeploymentDescriptor(DeploymentDescriptor deploymentDescriptor)